--- linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/f_hid.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/f_hid.c	2014-07-29 17:28:38.819972000 +0800
@@ -34,6 +34,9 @@
 	char				*report_desc;
 	unsigned short			report_length;
 
+	char                            feature_report[10][257];
+	unsigned short                  feature_report_length[10];
+
 	/* recv report */
 	char				*set_report_buff;
 	unsigned short			set_report_length;
@@ -50,6 +53,7 @@
 	struct cdev			cdev;
 	struct usb_function		func;
 	struct usb_ep			*in_ep;
+    unsigned char           config_status;
 };
 
 static inline struct f_hidg *func_to_hidg(struct usb_function *f)
@@ -90,7 +94,7 @@
 	.bEndpointAddress	= USB_DIR_IN,
 	.bmAttributes		= USB_ENDPOINT_XFER_INT,
 	/*.wMaxPacketSize	= DYNAMIC */
-	.bInterval		= 4, /* FIXME: Add this field in the
+	.bInterval		= 1, /* FIXME: Add this field in the
 				      * HID gadget configuration?
 				      * (struct hidg_func_descriptor)
 				      */
@@ -200,13 +204,18 @@
 
 	/* write queue */
 	while (!WRITE_COND) {
+                long wait_return;
+
 		mutex_unlock(&hidg->lock);
 		if (file->f_flags & O_NONBLOCK)
 			return -EAGAIN;
-
-		if (wait_event_interruptible_exclusive(
-				hidg->write_queue, WRITE_COND))
+		
+                wait_return = wait_event_interruptible_timeout(hidg->write_queue, WRITE_COND, 10/*ms*/);
+               
+                if (wait_return == -ERESTARTSYS)
 			return -ERESTARTSYS;
+                else if (wait_return == 0)
+                        return -EAGAIN;
 
 		mutex_lock(&hidg->lock);
 	}
@@ -278,6 +287,31 @@
 
 	return 0;
 }
+static long f_hidg_ioctl(struct file *fd, unsigned int code, unsigned long arg)
+{
+    struct f_hidg   *hidg  = fd->private_data;
+    unsigned long       flags;
+    int         status = 0;
+    
+    //printk("f_hidg_ioctl: cmd=0x%4.4x, arg=%lu\n", code, arg);
+    
+    /* handle ioctls */
+    spin_lock_irqsave(&hidg->spinlock, flags);
+    
+    switch (code) {
+        case GET_GADGET_HID_DEVICE_CONFIG_STATUS:
+            printk(KERN_DEBUG "\nhidg->config_status : %d\n", hidg->config_status);
+            copy_to_user((void __user *)arg, (const void *)&hidg->config_status, sizeof(hidg->config_status));
+            break;
+        default:
+            /* could not handle ioctl */
+            printk("f_hidg_ioctl: ERROR cmd=0x%4.4xis not supported\n", code);
+            status = -ENOTTY;
+    }
+    
+    spin_unlock_irqrestore(&hidg->spinlock, flags);
+    return status;
+}
 
 /*-------------------------------------------------------------------------*/
 /*                                usb_function                             */
@@ -328,9 +362,22 @@
 		  | HID_REQ_GET_REPORT):
 		VDBG(cdev, "get_report\n");
 
+#ifdef CONFIG_USB_G_HID_MULTITOUCH
+		if (hidg->feature_report_length[value & 0xff]) {
+                        length = min_t(unsigned, length, hidg->feature_report_length[value & 0xff]);
+                        VDBG(cdev,"Found feature report of length %d for report id %d\n", hidg->feature_report_length[value & 0xff], value&0xff);
+                        memcpy(req->buf, &hidg->feature_report[value & 0xff], length);
+                } else {
+                        VDBG(cdev,"Couldn't find a feature report for %d of length <= %d\n", value & 0xff, length);
+                        /* send an empty report */
+                        length = min_t(unsigned, length, hidg->report_length);
+                        memset(req->buf, 0x0, length);
+                }
+#else
 		/* send an empty report */
 		length = min_t(unsigned, length, hidg->report_length);
 		memset(req->buf, 0x0, length);
+#endif
 
 		goto respond;
 		break;
@@ -344,6 +391,12 @@
 	case ((USB_DIR_OUT | USB_TYPE_CLASS | USB_RECIP_INTERFACE) << 8
 		  | HID_REQ_SET_REPORT):
 		VDBG(cdev, "set_report | wLenght=%d\n", ctrl->wLength);
+
+                length = min_t(unsigned, length, sizeof(hidg->feature_report[value & 0xff]));
+                VDBG(cdev,"Received feature report of length %d for report id %d\n", length, value&0xff);
+                memcpy(&hidg->feature_report[value & 0xff], req->buf, length);
+                hidg->feature_report_length[value & 0xff] = length;
+
 		req->context  = hidg;
 		req->complete = hidg_set_report_complete;
 		goto respond;
@@ -381,9 +434,20 @@
 		}
 		break;
 
+	case ((USB_DIR_OUT | USB_TYPE_CLASS | USB_RECIP_INTERFACE) << 8
+		  | USB_REQ_GET_INTERFACE):
+        VDBG(cdev,"USB_REQ_GET_INTERFACE : Assuming Request for Interface Number\n");
+        //VDBG(cdev,"Requested Length : %d\n", length);
+        *(u8 *)req->buf = hidg->minor; 
+        /* Under the assumption that Interface Detail Request comes from Host at end of setup process
+         * Marking Configuration Status as Done. 
+         * TODO : Need to come up with better mechanism to detect setup/configuration completion   
+         */ 
+        hidg->config_status =  CONFIG_DONE;
+        goto respond;
+        break;
 	default:
-		VDBG(cdev, "Unknown request 0x%x\n",
-			 ctrl->bRequest);
+		printk("Unknown Request Type : 0x%2x or Request 0x%2x\n", (ctrl->bRequestType << 8), ctrl->bRequest);
 		goto stall;
 		break;
 	}
@@ -446,6 +510,7 @@
 	.read		= f_hidg_read,
 	.poll		= f_hidg_poll,
 	.llseek		= noop_llseek,
+    .unlocked_ioctl = f_hidg_ioctl,
 };
 
 static int __init hidg_bind(struct usb_configuration *c, struct usb_function *f)
@@ -616,6 +681,9 @@
 		return -ENOMEM;
 	}
 
+        memcpy(hidg->feature_report_length, fdesc->feature_report_length, sizeof(hidg->feature_report_length));
+        memcpy(hidg->feature_report, fdesc->feature_report, sizeof(hidg->feature_report));
+
 	hidg->func.name    = "hid";
 	hidg->func.strings = ct_func_strings;
 	hidg->func.bind    = hidg_bind;
@@ -623,10 +691,13 @@
 	hidg->func.set_alt = hidg_set_alt;
 	hidg->func.disable = hidg_disable;
 	hidg->func.setup   = hidg_setup;
+    hidg->config_status =  CONFIG_NOT_DONE;
 
 	status = usb_add_function(c, &hidg->func);
-	if (status)
+	if (status) {
+		kfree(hidg->report_desc);
 		kfree(hidg);
+        }
 
 	return status;
 }
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/file_storage.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/file_storage.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/file_storage.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/file_storage.c	2014-07-29 17:28:38.819972000 +0800
@@ -572,9 +572,47 @@
 	.bConfigurationValue =	CONFIG_VALUE,
 	.iConfiguration =	FSG_STRING_CONFIG,
 	.bmAttributes =		USB_CONFIG_ATT_ONE | USB_CONFIG_ATT_SELFPOWER,
-	.bMaxPower =		CONFIG_USB_GADGET_VBUS_DRAW / 2,
+//	.bMaxPower =		CONFIG_USB_GADGET_VBUS_DRAW / 2,
+	.bMaxPower =		0,	// self-powered
 };
 
+#ifdef CONFIG_USB_DWC_OTG_LPM
+
+/* USB_DT_BOS:  group of wireless capabilities */
+struct bos_desc {
+	__u8  bLength;
+	__u8  bDescriptorType;
+
+	__le16 wTotalLength;
+	__u8  bNumDeviceCaps;
+} __attribute__ ((__packed__));
+
+struct usb20_ext_cap_desc {
+            __u8 bLength;
+            __u8 bDescriptorType;
+            __u8 bDevCapabilityType;
+            __le32 bmAttributes;
+} __attribute__ ((__packed__));
+
+/** The BOS Descriptor */
+#define USB_CAP_20_EXT		0x02
+#define USB_20_EXT_LPM		0x02
+
+static struct usb20_ext_cap_desc cap_lpm = {
+            .bLength = sizeof(struct usb20_ext_cap_desc),
+            .bDescriptorType = USB_DT_DEVICE_CAPABILITY,
+            .bDevCapabilityType = USB_CAP_20_EXT,
+            .bmAttributes = cpu_to_le32(USB_20_EXT_LPM),
+};
+
+static struct bos_desc bos = {
+            .bLength = sizeof(struct bos_desc),
+            .bDescriptorType = USB_DT_BOS,
+            .wTotalLength = cpu_to_le16(sizeof(struct bos_desc) + sizeof(cap_lpm)),
+            .bNumDeviceCaps = 1,
+};
+ 
+#endif
 
 static struct usb_qualifier_descriptor
 dev_qualifier = {
@@ -943,6 +981,17 @@
 		case USB_DT_DEVICE:
 			VDBG(fsg, "get device descriptor\n");
 			device_desc.bMaxPacketSize0 = fsg->ep0->maxpacket;
+#ifdef CONFIG_USB_DWC_OTG_LPM
+                        /* Set the bcdUSB to 0201H to indicate support
+                        * for the BOS Descriptor. */
+                        if (usb_gadget_test_lpm_support(fsg->gadget)) {
+                                VDBG(fsg, "set bcdUSB to 0201h\n");
+                                device_desc.bcdUSB = 0x201;
+                        } else {
+                                VDBG(fsg, "set bcdUSB to 0200h\n");
+                                 device_desc.bcdUSB = 0x200;
+                        }
+#endif
 			value = sizeof device_desc;
 			memcpy(req->buf, &device_desc, value);
 			break;
@@ -956,6 +1005,18 @@
 			 * speeds
 			 */
 			dev_qualifier.bMaxPacketSize0 = fsg->ep0->maxpacket;
+#ifdef CONFIG_USB_DWC_OTG_LPM
+                        /* Set the bcdUSB to 0201H to indicate support
+                        * for the BOS Descriptor. */
+                        if (usb_gadget_test_lpm_support(fsg->gadget)) {
+                                VDBG(fsg, "set bcdUSB to 0201h\n");
+                                dev_qualifier.bcdUSB = 0x201;
+                        } else {
+                                VDBG(fsg, "set bcdUSB to 0200h\n");
+                                 dev_qualifier.bcdUSB = 0x200;
+                        }
+#endif
+
 			value = sizeof dev_qualifier;
 			memcpy(req->buf, &dev_qualifier, value);
 			break;
@@ -989,6 +1050,20 @@
 			if (gadget_is_superspeed(fsg->gadget))
 				value = populate_bos(fsg, req->buf);
 			break;
+#ifdef CONFIG_USB_DWC_OTG_LPM
+		case USB_DT_BOS:
+			if (usb_gadget_test_lpm_support(fsg->gadget)) {
+			        VDBG(fsg, "LPM support enabled in DWC UDC PCD\n");
+                                cap_lpm.bmAttributes |= USB_20_EXT_LPM;
+                        	__u8 *buf = req->buf;
+				VDBG(fsg, "get bos descriptor\n");
+				memcpy(buf, &bos, sizeof bos);
+				buf += sizeof bos;
+				memcpy(buf, &cap_lpm, sizeof cap_lpm);
+				value = sizeof bos + sizeof cap_lpm;
+				break;
+			}
+#endif
 		}
 
 		break;
@@ -3232,7 +3307,13 @@
 		gcnum = usb_gadget_controller_number(fsg->gadget);
 		if (gcnum >= 0)
 			mod_data.release = 0x0300 + gcnum;
-		else {
+		else if (gadget_is_dwc_otg(fsg->gadget)) {
+			mod_data.release = __constant_cpu_to_le16 (0x0200);
+			mod_data.vendor  = __constant_cpu_to_le16 (0x053f);
+			if (mod_data.product == FSG_PRODUCT_ID) {
+				mod_data.product  = __constant_cpu_to_le16 (0x0000);
+			}
+		} else {
 			WARNING(fsg, "controller '%s' not recognized\n",
 				fsg->gadget->name);
 			mod_data.release = 0x0399;
@@ -3493,6 +3574,14 @@
 
 	rc = -ENOMEM;
 
+#ifdef CONFIG_USB_DWC_OTG_LPM
+	/* When LPM is enabled, Inform the host that the remote wake
+ 	 * up capability is supported. */
+	if (usb_gadget_test_lpm_support(fsg->gadget)) {
+		config_desc.bmAttributes |= USB_CONFIG_ATT_WAKEUP;
+	}
+#endif
+
 	/* Allocate the request and buffer for endpoint 0 */
 	fsg->ep0req = req = usb_ep_alloc_request(fsg->ep0, GFP_KERNEL);
 	if (!req)
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/gadget_chips.h linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/gadget_chips.h
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/gadget_chips.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/gadget_chips.h	2014-07-29 17:28:38.819972000 +0800
@@ -122,6 +122,11 @@
 	return -ENOENT;
 }
 
+#ifdef CONFIG_USB_GADGET_SNPS_DWC_OTG
+#define        gadget_is_dwc_otg(g)    !strcmp("dwc_otg_pcd", (g)->name)
+#else
+#define        gadget_is_dwc_otg(g)    0
+#endif
 
 /**
  * gadget_supports_altsettings - return true if altsettings work
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/hid.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/hid.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/hid.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/hid.c	2015-04-29 14:37:06.741752000 +0800
@@ -15,15 +15,14 @@
 #include <linux/kernel.h>
 #include <linux/platform_device.h>
 #include <linux/list.h>
+#include <linux/timex.h>
 
 #define DRIVER_DESC		"HID Gadget"
-#define DRIVER_VERSION		"2010/03/16"
+#define DRIVER_VERSION		"2013/10/11"
 
 /*-------------------------------------------------------------------------*/
-
-#define HIDG_VENDOR_NUM		0x0525	/* XXX NetChip */
+#define HIDG_VENDOR_NUM		0x0525	/* XXX NetChip */ /* TODO: Need to change Vendor Number */
 #define HIDG_PRODUCT_NUM	0xa4ac	/* Linux-USB HID gadget */
-
 /*-------------------------------------------------------------------------*/
 
 /*
@@ -190,6 +189,9 @@
 	strings_dev[STRING_PRODUCT_IDX].id = status;
 	device_desc.iProduct = status;
 
+	device_desc.idVendor = (jiffies >> 16) & 0xFFFF;
+	device_desc.idProduct = (jiffies >> 0) & 0xFFFF;
+
 	/* register our configuration */
 	status = usb_add_config(cdev, &config_driver, do_config);
 	if (status < 0)
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -943,6 +943,47 @@
 	  Say "y" to link the driver statically, or "m" to build a
 	  dynamically linked module called "g_hid".
 
+config USB_G_HID_KEYBOARD
+        bool "Emulates Generic Keyboard"
+        depends on USB_G_HID
+        default n
+        help
+          This option will add Keyboard to the list of devices 
+          supported through USB back-channel.
+
+config USB_G_HID_MOUSE
+        bool "Emulates Generic Mouse"
+        depends on USB_G_HID
+        default n
+        help
+          This option will add Mouse to the list of devices 
+          supported through USB back-channel.
+
+config USB_G_HID_JOYSTICK
+        bool "Emulates Generic Joystick"
+        depends on USB_G_HID
+        default n
+        help
+          This option will add Joystick to the list of devices 
+          supported through USB back-channel.
+config USB_G_HID_MCU
+        bool "Emulate 1900_FJ_RX's MCU"
+        depends on USB_G_HID
+        default n
+        help
+          This option will add MCU to the list of devices 
+          supported through USB back-channel for Fujitsu's 
+          WILL PC.
+
+config USB_G_HID_MULTITOUCH
+        bool "Emulate 1900_FJ_RX's HID multi-touch"
+        depends on USB_G_HID
+        default n
+        help
+          This option will add eGalax multi-touch panel 
+          to the list of devices supported through USB 
+          back-channel for Fujitsu's WILL PC.
+
 config USB_G_DBGP
 	tristate "EHCI Debug Device Gadget"
 	help
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/printer.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/printer.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/storage_common.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/storage_common.c	2014-07-29 17:28:38.819972000 +0800
@@ -335,6 +335,9 @@
 	.bDescriptorType =	USB_DT_OTG,
 
 	.bmAttributes =		USB_OTG_SRP,
+#ifdef CONFIG_USB_SNPS_DWC_OTG2
+	.bcdOTG =	0x200,
+#endif
 };
 #endif
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/gadget/udc-core.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/gadget/udc-core.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/host/ehci-platform.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/host/ehci-platform.c	2014-07-29 17:28:38.819972000 +0800
@@ -18,6 +18,7 @@
  *
  * Licensed under the GNU/GPL. See COPYING for details.
  */
+#include <linux/clk.h>
 #include <linux/platform_device.h>
 #include <linux/usb/ehci_pdriver.h>
 
@@ -75,8 +76,6 @@
 	.relinquish_port	= ehci_relinquish_port,
 	.port_handed_over	= ehci_port_handed_over,
 
-	.update_device		= ehci_update_device,
-
 	.clear_tt_buffer_complete = ehci_clear_tt_buffer_complete,
 };
 
@@ -84,6 +83,7 @@
 {
 	struct usb_hcd *hcd;
 	struct resource *res_mem;
+	struct clk *clk;
 	int irq;
 	int err = -ENOMEM;
 
@@ -92,6 +92,15 @@
 	if (usb_disabled())
 		return -ENODEV;
 
+	clk = clk_get(&dev->dev, NULL);
+	if (IS_ERR(clk)) {
+		dev_err(&dev->dev, "failed to get clock\n");
+		return PTR_ERR(clk);
+	}
+
+	clk_prepare(clk);
+	clk_enable(clk);
+
 	irq = platform_get_irq(dev, 0);
 	if (irq < 0) {
 		pr_err("no irq provieded");
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/usb/host/ohci-hcd.c linux-linaro-3.4-2012.05-1_cavium/drivers/usb/host/ohci-hcd.c
--- linux-linaro-3.4-2012.05-1_original/drivers/usb/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/usb/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -20,6 +20,8 @@
 	default y if ARCH_CNS3XXX
 	default y if PLAT_SPEAR
 	default y if ARCH_EXYNOS
+	default y if ARCH_CELESTIAL
+
 	# PPC:
 	default y if STB03xxx
 	default y if PPC_MPC52xx
@@ -48,6 +50,7 @@
 	default y if SPARC_LEON
 	default y if ARCH_MMP
 	default y if MACH_LOONGSON1
+	default y if ARCH_CELESTIAL
 	default PCI
 
 # some non-PCI HCDs implement xHCI
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/cnc1900_fb_hw.c linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/cnc1900_fb_hw.c
